﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace CustomEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnRadDataFilterEditorCreated(object sender, Telerik.Windows.Controls.Data.DataFilter.EditorCreatedEventArgs e)
        {
            switch (e.ItemPropertyDefinition.PropertyName)
            {
                case "Time":

                    break;
                case "Name":
                    // This is a custom editor specified through the EditorTemplateSelector.
                    RadComboBox comboBoxEditor = (RadComboBox)e.Editor;
                    comboBoxEditor.ItemsSource = Club.GetClubs().Where(c => c.Name != null);
                    break;
                case "Established":
                    RadDateTimePicker dataPickerEditor = (RadDateTimePicker)e.Editor;
                    dataPickerEditor.InputMode = Telerik.Windows.Controls.InputMode.DateTimePicker;
                    break;
                case "StadiumCapacity":
                    RadSlider sliderEditor = (RadSlider)e.Editor;
                    var ordered = Club.GetClubs().OrderBy(c => c.StadiumCapacity);

                    sliderEditor.Minimum = ordered.First().StadiumCapacity;
                    sliderEditor.Maximum = ordered.Last().StadiumCapacity;
                    break;
                case "Captain":
                    RadComboBox playersComboBoxEditor = (RadComboBox)e.Editor;
                    var club = Club.GetClubs().ElementAt(0);
                    playersComboBoxEditor.ItemsSource = Club.GetClubs().Where(c => c.Captain != null).Select(c => c.Captain);
                    break;
            }
           
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(this.radDataFilter.FilterDescriptors.ToString());
        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {

        }
    }

    public class MyInvertedBooleanConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is bool)
            {
                return !((bool)value);
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is bool)
            {
                return !((bool)value);
            }

            return null;
        }
    }
}
